/**
 * @file
 * Snippet manager behaviors.
 */

(function ($, Drupal) {

  'use strict';

  Drupal.behaviors.snippetManagerCodeEditor = {
    attach: function (context, settings) {

      /* global CodeMirror */
      if (typeof CodeMirror == 'undefined') {
        alert(Drupal.t('CodeMirror library is not loaded!'));
        return;
      }

      var $textArea = $('.snippet-code-textarea:visible');
      if ($textArea[0]) {

        if ($textArea.hasClass('error')) {
          $textArea.parent().addClass('snippet-error');
        }

        var editor = CodeMirror.fromTextArea($textArea[0], {
          lineNumbers: true,
          mode: 'twig'
        });

        var doc = editor.getDoc();

        $('.snippet-variable').click(function () {
          doc.replaceRange('{{ ' + $(this).text() + ' }}', doc.getCursor());
          return false;
        });
      }

    }
  };

  Drupal.behaviors.snippet_managerExamplHtmlSource = {
    attach: function (context, settings) {

      var $textArea = $('.snippet-html-source:visible');
      if ($textArea[0]) {
        CodeMirror.fromTextArea($textArea[0], {
          mode: 'text/html',
          lineNumbers: true,
          readOnly: true,
          foldGutter: true,
          gutters: ['CodeMirror-linenumbers', 'CodeMirror-foldgutter']
        });
      }

    }
  };

}(jQuery, Drupal));
